"""
    A8 starter code written by David Johnson. All derived works must not
    be posted publicly.

    A8 assignment completed by
"""


# Fill in the required assignment functions below here.
def curve_scores(list_of_ints):
    new_list = []
    highest_score = 0
    for item in list_of_ints:
        if item > highest_score:
            highest_score = item
    difference = 100 - highest_score
    for item in list_of_ints:
        new_list.append(item + difference)
    return new_list

def list_to_string(list_of_ints):
    new_list = []
    for i in range(len(list_of_ints)):
        new_list.append(str(list_of_ints[i]))
    return new_list

def find_smallest_positive_number(list_of_ints):
    smallest_positive = 0
    for number in list_of_ints:
        if number > 0:
            smallest_positive = number
            break
    for number in list_of_ints:
        if smallest_positive >= number > 0:
            smallest_positive = number
    if smallest_positive == 0:
        return False
    else:
        return smallest_positive

def lines_from_file(filename):
    new_list = []
    for line in filename:
        new_list.append(line)
    return new_list

def binary_search_for_matching_string(key, values):
    """
    Return the location of key in the values list, or None if no match. This function uses
    binary search to efficiently search a sorted list.

    :param key: The item to search for
    :param values: A sorted list of values
    :return: The location of the matching item or None if no match.
    """
    lo = 0
    hi = len(values) - 1
    while lo <= hi:
        mid = lo + (hi - lo) // 2
        if key.startswith(values[mid]):  # if key found return where it is
            return values[mid]
        elif values[mid] < key: # If the checked value is less than key, remove left half of list
            lo = mid + 1
        else:                   # If the checked value is greater than key, remove right half of list
            hi = mid - 1
    return None



def binary_search_for_key(key, values):
    """
    Return the location of key in the values list, or None if no match. This function uses
    binary search to efficiently search a sorted list.

    :param key: The item to search for
    :param values: A sorted list of values
    :return: The location of the matching item or None if no match.
    """
    lo = 0
    hi = len(values) - 1
    while lo <= hi:
        mid = lo + (hi - lo) // 2
        if values[mid] == key:  # if key found return where it is
            return mid
        elif values[mid] < key: # If the checked value is less than key, remove left half of list
            lo = mid + 1
        else:                   # If the checked value is greater than key, remove right half of list
            hi = mid - 1
    return None


def main():
    # print(curve_scores([45, 65, 70, 90, 80]))
    # print(contains_duplicate([55, 65, 80, 8, 65]))
    print(list_to_string([1, 2, 3]))
    # print(find_smallest_positive_number([10, -4, 6, -1]))
if __name__ == "__main__":
    main()
